<template>
  <div class="overview">
    <b-card
      @click.prevent="setComponent('Setup')"
      v-if="resource !== undefined && resource.resourceTypeOption !== undefined"
    >
      <h4>{{ $t("resourceconfiguration") }}</h4>
      <span
        v-for="resourceTypeOptionKey of Object.keys(
          resource.resourceTypeOption
        )"
        :key="resourceTypeOptionKey"
      >
        <coscine-form-group
          v-if="resourceTypeOptionKey !== 'Id'"
          :mandatory="true"
          :labelFor="resourceTypeOptionKey"
          :label="$t(resourceTypeOptionKey + 'Label')"
        >
          <b-form-input
            v-if="
              resourceTypeOptionKey !== 'AccessKey' &&
              resourceTypeOptionKey !== 'SecretKey' &&
              resourceTypeOptionKey !== 'Token' &&
              resourceTypeOptionKey !== 'Size'
            "
            readonly="readonly"
            v-model="resource.resourceTypeOption[resourceTypeOptionKey]"
          />
          <b-form-input
            v-else-if="resourceTypeOptionKey === 'Size'"
            readonly="readonly"
            :value="resource.resourceTypeOption[resourceTypeOptionKey] + ' GB'"
          />
          <b-form-input
            v-else
            readonly="readonly"
            type="password"
            value="placeholder"
          />
        </coscine-form-group>
      </span>
    </b-card>
    <b-card @click.prevent="setComponent('GeneralInfo')">
      <h4>{{ $t("generalinformation") }}</h4>
      <b-form @submit.stop.prevent="onSubmit">
        <coscine-form-group
          :mandatory="true"
          labelFor="ResourceName"
          :label="$t('ResourceNameLabel')"
        >
          <b-form-input
            id="ResourceName"
            readonly="readonly"
            v-model="resource.ResourceName"
          />
        </coscine-form-group>
        <coscine-form-group
          :mandatory="true"
          labelFor="DisplayName"
          :label="$t('DisplayNameLabel')"
        >
          <b-form-input
            id="DisplayName"
            readonly="readonly"
            v-model="resource.DisplayName"
          />
        </coscine-form-group>
        <coscine-form-group
          :mandatory="true"
          labelFor="Description"
          :label="$t('ResourceDescriptionLabel')"
        >
          <b-form-textarea
            id="Description"
            readonly="readonly"
            v-model="resource.Description"
          />
        </coscine-form-group>
        <coscine-form-group
          :mandatory="true"
          labelFor="Disciplines"
          :label="$t('ResourceDisciplineLabel')"
        >
          <multiselect
            id="Disciplines"
            v-model="resource.Disciplines"
            readonly="readonly"
            :disabled="true"
            :options="resource.Disciplines"
            :multiple="true"
            :label="disciplineLabel"
          >
            <template
              slot="singleLabel"
              slot-scope="props"
              v-bind:disabled="true"
              >{{ props.option[disciplineLabel] }}</template
            >
            <template slot="option" slot-scope="props" v-bind:disabled="true">{{
              props.option[disciplineLabel]
            }}</template>
          </multiselect>
        </coscine-form-group>
        <coscine-form-group
          labelFor="Keywords"
          :label="$t('ResourceKeywordsLabel')"
        >
          <multiselect
            id="Keywords"
            readonly="readonly"
            :disabled="true"
            v-model="resource.Keywords"
            :options="resource.Keywords"
            :placeholder="$t('ResourceKeywords')"
            :multiple="true"
          >
          </multiselect>
        </coscine-form-group>
        <!-- functionality is not implemented yet, so this option is commented out (#1686)
        <coscine-form-group :mandatory="true" labelFor="Visibility" :label="$t('ResourceVisibilityLabel')">
          <b-form-input id="Visibility" readonly="readonly" v-model="resource.Visibility.displayName" />
        </coscine-form-group>-->
        <coscine-form-group
          labelFor="ResourceLicense"
          :label="$t('ResourceLicenseLabel')"
          :info="true"
        >
          <template #popover>
            {{ $t("popoverLicense") }}
            <b-link
              href="https://help.itc.rwth-aachen.de/service/b2b7729fd93f4c7080b475776f6b5d87/article/7812e3fcd3a241808f5b91e11b6ca3a9/"
              target="_blank"
              >{{ $t("help") }}</b-link
            >
          </template>
          <b-form-input
            v-if="resource.License !== null"
            id="ResourceLicense"
            readonly="readonly"
            v-model="resource.License.displayName"
          />
          <b-form-input
            v-else
            id="ResourceLicense"
            readonly="readonly"
            value=""
          />
        </coscine-form-group>
        <coscine-form-group
          labelFor="UsageRights"
          :label="$t('ResourceUsageRightsLabel')"
          :info="true"
        >
          <template #popover>
            {{ $t("popoverUsageRights") }}
            <b-link
              href="https://help.itc.rwth-aachen.de/service/b2b7729fd93f4c7080b475776f6b5d87/article/7812e3fcd3a241808f5b91e11b6ca3a9/"
              target="_blank"
              >{{ $t("help") }}</b-link
            >
          </template>
          <b-form-input
            id="UsageRights"
            readonly="readonly"
            v-model="resource.UsageRights"
          />
        </coscine-form-group>
        <coscine-form-group :mandatory="true" labelFor="PID" :label="$t('PID')">
          <b-form-input id="PID" readonly="readonly" v-model="resource.PID" />
        </coscine-form-group>
      </b-form>
    </b-card>
    <b-card @click.prevent="setComponent('Metadata')">
      <h4>{{ $t("metadata") }}</h4>
      <FormGenerator
        :key="resource.applicationProfile"
        :projectId="projectId"
        :fixedValueMode="fixedValueMode"
        :fixedValues="resource.fixedValues"
        :applicationProfileId="resource.applicationProfile"
        :disabledMode="true"
        :SHACLDefinition="JSON.stringify(applicationProfile)"
        mimeType="application/ld+json"
      />
    </b-card>
    <b-button
      @click.prevent="back"
      class="btn btn-secondary"
      variant="outline-primary"
      >{{ $t("back") }}</b-button
    >
    <b-button
      @click.prevent="store"
      :disabled="isUploadInProgess"
      class="float-right"
      variant="primary"
      >{{ $t("confirm") }}</b-button
    >
    <b-toast
      id="error-message"
      :title="$t('resourceCreationErrorHeader')"
      toaster="b-toaster-bottom-right"
      variant="warning"
      no-auto-hide
    >
      {{ $t("resourceCreationError") }}
      <b-link href="mailto:servicedesk@itc.rwth-aachen.de"
        >servicedesk@itc.rwth-aachen.de</b-link
      >
    </b-toast>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import { MetadataApi, ResourceApi } from "@coscine/api-connection";

import Multiselect from "vue-multiselect";
import "vue-multiselect/dist/vue-multiselect.min.css";
Vue.component("multiselect", Multiselect);

import { LanguageUtil, LinkUtil } from "@coscine/app-util";
import { CoscineFormGroup } from "@coscine/component-library";
import "@coscine/component-library/dist/index.css";

import FormGenerator from "@coscine/form-generator";
import "@coscine/form-generator/dist/index.css";
Vue.use(FormGenerator);

function parseKeywords(form: any, delimiter = ";") {
  // combine array values to a string (using the 'keyword' form input)
  if (typeof form.Keywords !== "string") {
    let keywordString = "";
    for (const keyword of form.Keywords) {
      keywordString += keyword + delimiter;
    }
    if (keywordString.charAt(keywordString.length - 1) === delimiter) {
      keywordString = keywordString.substring(0, keywordString.length - 1);
    }
    form.Keywords = keywordString;
  }
}

export default Vue.extend({
  name: "Overview",
  components: {
    CoscineFormGroup,
  },
  data() {
    return {
      isUploadInProgess: false,
      disciplineLabel: "displayNameEn",
      fixedValueMode: true,
    };
  },
  methods: {
    back() {
      this.$emit("back");
    },
    setWaitingForResponse(newIsWaitingForResponse: boolean) {
      this.$emit("waitingForResponse", newIsWaitingForResponse);
    },
    setComponent(component: string) {
      this.$emit("switchPage", component);
    },
    store() {
      if (!this.isWaitingForResponse) {
        this.$emit("waitingForResponse", true);
        this.isUploadInProgess = true;
        parseKeywords(this.resource, ";");
        ResourceApi.storeResource(
          this.projectId,
          this.resource,
          (response: any) => LinkUtil.redirectToProject(),
          (error: any) => {
            this.$emit("waitingForResponse", false);
            this.$bvToast.show("error-message");
          }
        );
      }
    },
  },
  props: {
    resource: Object,
    projectId: String,
    isOwner: Boolean,
    isWaitingForResponse: Boolean,
    selectedResourceTypeInformation: Object,
    applicationProfile: Array,
  },
  beforeMount() {
    if (LanguageUtil.getLanguage() === "en") {
      this.disciplineLabel = "displayNameEn";
    } else {
      this.disciplineLabel = "displayNameDe";
    }
  },
});
</script>

<style scoped>
.card {
  cursor: pointer;
  margin-bottom: 1em;
}
.multiselect {
  height: auto !important;
}
#FormGenerator {
}
</style>
